strange "0x0" mode in xrandr mode list

Bug #398188 reported by Andreas Schildbach on 2009-07-11
14
This bug affects 2 people
Affects Status Importance Assigned to Milestone
xf86-video-intel
Fix Released
Medium
linux (Ubuntu)
Low
Leann Ogasawara
Karmic
Low
Leann Ogasawara

Bug Description

Binary package hint: xserver-xorg-video-intel

On Karmic with KMS enabled, xrandr lists a mode with no resolution and no hsync:

$ xrandr
Screen 0: minimum 320 x 200, current 1920 x 1968, maximum 2048 x 2048
VGA1 connected 1920x1200+0+0 (normal left inverted right x axis y axis) 519mm x 324mm
   1920x1200 60.0*+
   1280x1024 75.0
   1024x768 75.1 60.0
   800x600 75.0 60.3
   640x480 75.0 60.0
   720x400 70.1
LVDS1 connected 1280x768+349+1200 (normal left inverted right x axis y axis) 264mm x 159mm
   1280x768 59.9*+
   800x600 60.3
   640x480 59.9
   0x0 0.0
TV1 disconnected (normal left inverted right x axis y axis)

This feels weird. Note that there used to be a 1024x768 mode detected on LVDS1, so maybe the 0x0 mode is a remnant of this.

ProblemType: Bug
Architecture: i386
Date: Sat Jul 11 17:06:57 2009
DistroRelease: Ubuntu 9.10
MachineType: Dell Inc. Latitude X1
Package: xserver-xorg-video-intel 2:2.7.99.901+git20090702.74227141-0ubuntu1
ProcCmdLine: root=UUID=b17e1aff-9f02-4fbd-81e5-9b1e6899baad ro quiet splash
ProcEnviron:
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 2.6.31-2.17-generic
RelatedPackageVersions:
 xserver-xorg 1:7.4+3ubuntu5
 libgl1-mesa-glx 7.5~rc4-1ubuntu3
 libdrm2 2.4.11-1ubuntu1
 xserver-xorg-video-intel 2:2.7.99.901+git20090702.74227141-0ubuntu1
 xserver-xorg-video-ati 1:6.12.99+git20090629.f39cafc5-0ubuntu1
SourcePackage: xserver-xorg-video-intel
Uname: Linux 2.6.31-2-generic i686
dmi.bios.date: 04/05/2005
dmi.bios.vendor: Dell Inc.
dmi.bios.version: A02
dmi.board.name: 0G6951
dmi.board.vendor: Dell Inc.
dmi.chassis.type: 8
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvrA02:bd04/05/2005:svnDellInc.:pnLatitudeX1:pvr:rvnDellInc.:rn0G6951:rvr:cvnDellInc.:ct8:cvr:
dmi.product.name: Latitude X1
dmi.sys.vendor: Dell Inc.
fglrx: Not loaded
system:
 distro: Ubuntu
 architecture: i686kernel: 2.6.31-2-generic

Andreas Schildbach (schildbach) wrote :
Bryce Harrington (bryce) on 2009-07-13
Changed in xserver-xorg-video-intel (Ubuntu):
status: New → Confirmed

Created an attachment (id=27714)
dmesg

Forwarding this bug from Ubuntu reporter Andreas Schildbach:
https://bugs.edge.launchpad.net/ubuntu/+source/xserver-xorg-video-intel/+bug/398188

[Problem]
On Karmic with KMS enabled, xrandr lists a mode with no resolution and no hsync:

$ xrandr
Screen 0: minimum 320 x 200, current 1920 x 1968, maximum 2048 x 2048
VGA1 connected 1920x1200+0+0 (normal left inverted right x axis y axis) 519mm x 324mm
   1920x1200 60.0*+
   1280x1024 75.0
   1024x768 75.1 60.0
   800x600 75.0 60.3
   640x480 75.0 60.0
   720x400 70.1
LVDS1 connected 1280x768+349+1200 (normal left inverted right x axis y axis) 264mm x 159mm
   1280x768 59.9*+
   800x600 60.3
   640x480 59.9
   0x0 0.0
TV1 disconnected (normal left inverted right x axis y axis)

This feels weird. Note that there used to be a 1024x768 mode detected on LVDS1, so maybe the 0x0 mode is a remnant of this.

ProblemType: Bug
Architecture: i386
Date: Sat Jul 11 17:06:57 2009
DistroRelease: Ubuntu 9.10
MachineType: Dell Inc. Latitude X1
Package: xserver-xorg-video-intel 2:2.7.99.901+git20090702.74227141-0ubuntu1
ProcCmdLine: root=UUID=b17e1aff-9f02-4fbd-81e5-9b1e6899baad ro quiet splash
ProcEnviron:
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 2.6.31-2.17-generic
RelatedPackageVersions:
 xserver-xorg 1:7.4+3ubuntu5
 libgl1-mesa-glx 7.5~rc4-1ubuntu3
 libdrm2 2.4.11-1ubuntu1
 xserver-xorg-video-intel 2:2.7.99.901+git20090702.74227141-0ubuntu1
 xserver-xorg-video-ati 1:6.12.99+git20090629.f39cafc5-0ubuntu1
SourcePackage: xserver-xorg-video-intel
Uname: Linux 2.6.31-2-generic i686
dmi.bios.date: 04/05/2005
dmi.bios.vendor: Dell Inc.
dmi.bios.version: A02
dmi.board.name: 0G6951
dmi.board.vendor: Dell Inc.
dmi.chassis.type: 8
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvrA02:bd04/05/2005:svnDellInc.:pnLatitudeX1:pvr:rvnDellInc.:rn0G6951:rvr:cvnDellInc.:ct8:cvr:
dmi.product.name: Latitude X1
dmi.sys.vendor: Dell Inc.
fglrx: Not loaded
system:
 distro: Ubuntu
 architecture: i686kernel: 2.6.31-2-generic

tags: added: karmic

Created an attachment (id=27715)
XorgConf.txt

xorg.conf is plain stock config

Created an attachment (id=27716)
XorgLog.txt

Created an attachment (id=27717)
Xrandr.txt

Created an attachment (id=27718)
xdpyinfo.txt

Bryce Harrington (bryce) wrote :

Hi Andreas,

I've forwarded your bug upstream to https://bugs.freedesktop.org/show_bug.cgi?id=22778 - please subscribe to this bug in case upstream needs more information or wishes you to test something. Thanks ahead of time!

Changed in xserver-xorg-video-intel (Ubuntu):
importance: Undecided → Low
status: Confirmed → Triaged
Changed in xserver-xorg-video-intel:
status: Unknown → Confirmed

Will you please attach the xrandr/xorg under UMS mode?
Thanks.

Here is how xrandr looks like on Jaunty xserver-xorg-video-intel 2:2.6.3-0ubuntu9.3 with no KMS. Note the additional 1024x768 resolution and the missing TV1 (which is correct since my hardware does not have TV out).

$ xrandr
Screen 0: minimum 320 x 200, current 1920 x 1968, maximum 1920 x 1968
VGA connected 1920x1200+0+0 (normal left inverted right x axis y axis) 519mm x 324mm
   1920x1200 60.0*+
   1600x1200 60.0
   1680x1050 60.0
   1280x1024 75.0 60.0
   1152x864 75.0
   1024x768 75.0 60.0
   800x600 75.0 60.3
   640x480 75.0 59.9
   720x400 70.1
LVDS connected 1280x768+0+1200 (normal left inverted right x axis y axis) 264mm x 159mm
   1280x768 59.9*+
   1024x768 60.0
   800x600 60.3
   640x480 59.9

And here is how xrandr looks like under Karmic xserver-xorg-video-intel 2:2.7.99.901+git20090702.74227141-0ubuntu1 with KMS disabled (booted with kernel option i915.modeset=0):

$ xrandr
Screen 0: minimum 320 x 200, current 1920 x 1968, maximum 2048 x 2048
VGA connected 1920x1200+0+0 (normal left inverted right x axis y axis) 519mm x 324mm
   1920x1200 60.0*+
   1600x1200 60.0
   1680x1050 60.0
   1280x1024 75.0 60.0
   1152x864 75.0
   1024x768 75.0 60.0
   800x600 75.0 60.3
   640x480 75.0 59.9
   720x400 70.1
LVDS connected 1280x768+330+1200 (normal left inverted right x axis y axis) 264mm x 159mm
   1280x768 59.9*+
   1024x768 60.0
   800x600 60.3
   640x480 59.9

Created an attachment (id=27751)
Xorg.0.log on Karmic with KMS disabled

Here is the Xorg.0.log on Karmic with KMS disabled (i915.modeset=0).

ykzhao, I hope this is what you meant with 'UMS mode'. Do you need more information?

Thanks for so quick response.
   What you have done is right. I expect to get the log with KMS disabled.
Thanks.

Changed in xserver-xorg-video-intel:
status: Confirmed → In Progress

Sorry for the late response.
   Will you please try the following patch set on the latest Eric's drm-intel-next tree and see whether the issue still exists?
    >http://lists.freedesktop.org/archives/intel-gfx/2009-July/003560.html
    >http://lists.freedesktop.org/archives/intel-gfx/2009-July/003561.html
    >http://lists.freedesktop.org/archives/intel-gfx/2009-July/003562.html

After the test, please attach the output of Xorg/xrandr.
   thanks.

Geir Ove Myhr (gomyhr) on 2009-07-26
tags: added: 915gm

Just for the records, kernel 2.6.31-4-generic does not fix the problem. Will try that patchset now.

Hmmm, are there step-by-step instructions of how to checkout that branch from git, apply the patches and install the kernel to Ubuntu Karmic?

As the three patches are already shipped in Dave's drm-next tree, this bug will be marked as resolved.
   1. commit d782c3f95c9263dc0b98e7115f75f1e18b9600b3
Author: Zhao Yakui <email address hidden>
Date: Mon Jun 22 13:17:08 2009 +0800

    drm/mode: add the CVT algorithm in kernel space

   2. commit 26bbdadad356ec02d33657858d91675f3e9aca94
Author: Zhao Yakui <email address hidden>
Date: Mon Jun 22 13:17:09 2009 +0800

    drm/mode: add the GTF algorithm in kernel space

   3. commit 5c61259e6c7290082108e93815f7f72f27da14f4
Author: Zhao Yakui <email address hidden>
Date: Mon Jun 22 13:17:10 2009 +0800

    drm/mode: get the modeline for standard timing in EDID by using CVT/GTF

   Please try the Dave's drm-next tree and see whether the issue is already fixed.
If the issue still exists, please reopen it again.
   Thanks.

Bryce Harrington (bryce) wrote :

According to the upstream bug report, this issue is likely fixed by three kernel patches, so I'm refiling this to the kernel.

   1. commit d782c3f95c9263dc0b98e7115f75f1e18b9600b3
Author: Zhao Yakui <email address hidden>
Date: Mon Jun 22 13:17:08 2009 +0800

    drm/mode: add the CVT algorithm in kernel space

   2. commit 26bbdadad356ec02d33657858d91675f3e9aca94
Author: Zhao Yakui <email address hidden>
Date: Mon Jun 22 13:17:09 2009 +0800

    drm/mode: add the GTF algorithm in kernel space

   3. commit 5c61259e6c7290082108e93815f7f72f27da14f4
Author: Zhao Yakui <email address hidden>
Date: Mon Jun 22 13:17:10 2009 +0800

    drm/mode: get the modeline for standard timing in EDID by using CVT/GTF

affects: xserver-xorg-video-intel (Ubuntu) → linux (Ubuntu)
Changed in linux (Ubuntu):
status: Triaged → New
tags: added: xorg-needs-kernel-fix
Changed in xserver-xorg-video-intel:
status: In Progress → Fix Released
Changed in linux (Ubuntu):
status: New → Triaged

Kernel 2.6.31-5-generic did _not_ fix the problem.

Kernel 2.6.31-5-generic does _not_ fix the problem.

(In reply to comment #14)
> Kernel 2.6.31-5-generic did _not_ fix the problem.
The patch I mentioned in comment #13 is not shipped in 2.6.31-rc5 kernel.
Please try the Dave's next tree.
Thanks.
>

Where can I find this "next tree"? I was asking for instructions.

Dozends of howto's and hours of git clone and compile time later, I am running "linux 2.6.31-rc2my" which is hopefully based on that "next tree".

And it does not fix this problem:

$ xrandr
Screen 0: minimum 320 x 200, current 1920 x 1968, maximum 4096 x 4096
VGA1 connected 1920x1200+0+0 (normal left inverted right x axis y axis) 519mm x 324mm
   1920x1200 60.0*+
   1280x1024 75.0
   1024x768 75.1 60.0
   800x600 75.0 60.3
   640x480 75.0 60.0
   720x400 70.1
LVDS1 connected 1280x768+304+1200 (normal left inverted right x axis y axis) 264mm x 159mm
   1280x768 59.9*+
   800x600 60.3
   640x480 59.9
   0x0 0.0
TV1 disconnected (normal left inverted right x axis y axis)

Changed in xserver-xorg-video-intel:
status: Fix Released → Confirmed

Will you please add the boot option of "drm.debug=0x6" and attach the output of dmesg, xorg.log?
Thaks.

Created an attachment (id=28581)
dmesg with drm.debug=0x6

Created an attachment (id=28582)
Xorg.log with drm.debug=0x6

(Oh sorry, I produced the two log files on the stock Karmic kernel. Should I have used the "next tree"?)

(In reply to comment #21)
> (Oh sorry, I produced the two log files on the stock Karmic kernel. Should I
> have used the "next tree"?)
>
It will be great if you can do the test on Dave's drm-next tree.
Thanks.

Created an attachment (id=28585)
dmesg with drm.debug=0x6 on the 'next tree'

Created an attachment (id=28586)
Xorg.log with drm.debug=0x6 on the 'next tree'

(In reply to comment #23)
> Created an attachment (id=28585) [details]
> dmesg with drm.debug=0x6 on the 'next tree'
From the dmesg it seems that the boot option of "drm.debug=0x06" has no effect.
Will you please enable "CONFIG_DRM=y" in kernel configuration and re-do the test again?
Thanks.
>

Created an attachment (id=28616)
dmesg with drm.debug=0x6 and CONFIG_DRM=y on the 'next tree'

Created an attachment (id=28617)
Xorg.log with drm.debug=0x6 and CONFIG_DRM=y on the 'next tree'

I switched CONFIG_DRM from 'm' to 'y' in '.config' and clean compiled the whole 'next tree' again. However, it does not look like there is any additional debug output.

I've tried everything to set DRM_CONFIG from 'm' to 'y'. It is always being reverted to 'm'. make menuconfig errors when switching to 'y' (dependency problem but there seems to be no option to set all dependencies to 'y').

So, please, would you exactly describe what I have to do in order to produce the required log files? (refering to existing howtos is ok of course)

sorry meant CONFIG_DRM in the above comment

(In reply to comment #29)
> I've tried everything to set DRM_CONFIG from 'm' to 'y'. It is always being
> reverted to 'm'. make menuconfig errors when switching to 'y' (dependency
> problem but there seems to be no option to set all dependencies to 'y').
>
Will you please compile the i915 as built-in driver and attach the required output?
Please confirm that the test is based on the drm-dave/drm-next tree.
   >http://git.kernel.org/?p=linux/kernel/git/airlied/drm-2.6.git;a=commit;h=cfcf4738cd6b5d7bed1473acad76d6430cf1fb0a

Thanks.
> So, please, would you exactly describe what I have to do in order to produce
> the required log files? (refering to existing howtos is ok of course)
>

Created an attachment (id=28620)
add the detailed mode debug info related with the output

Will you please also try the debug patch on the xserver and attach the xorg.log after the system is booted?
thanks.

Again, switching CONFIG_DRM_I915 yields the error "This This feature depends on another which has been configured as a module. As a result, this feature will be built as a module." when trying to switch from 'm' to 'y' within 'make menuconfig'. Could you give detailed instructions?

I do not know how to "confirm that the test is based on the drm-dave/drm-next tree". Could you give detailed instructions?

I do not know how to apply the patch on xserver. I have fetched the xserver source with "apt-get source xserver-xorg", but the source does not contain the file to be patched (xf86Crtc.c). Could you give detailed instructions?

Created an attachment (id=28666)
dmesg with drm.debug=0x6 and CONFIG_DRM[_I915]=y on the 'next tree'

Created an attachment (id=28667)
Xorg.log with mode_debug patch on the 'next tree'

(In reply to comment #33)
> Again, switching CONFIG_DRM_I915 yields the error "This This feature depends on
> another which has been configured as a module. As a result, this feature will
> be built as a module." when trying to switch from 'm' to 'y' within 'make
> menuconfig'. Could you give detailed instructions?
>
> I do not know how to "confirm that the test is based on the drm-dave/drm-next
> tree". Could you give detailed instructions?
>
> I do not know how to apply the patch on xserver. I have fetched the xserver
> source with "apt-get source xserver-xorg", but the source does not contain the
> file to be patched (xf86Crtc.c). Could you give detailed instructions?
You can download the xorg-xserver source code from
http://cgit.freedesktop.org/xorg/xserver/commit/?id=xorg-server-1.6.3
and then apply the patch on it.
Thanks.
>

(In reply to comment #33)
> Again, switching CONFIG_DRM_I915 yields the error "This This feature depends on
> another which has been configured as a module. As a result, this feature will
> be built as a module." when trying to switch from 'm' to 'y' within 'make
> menuconfig'. Could you give detailed instructions?
>
> I do not know how to "confirm that the test is based on the drm-dave/drm-next
> tree". Could you give detailed instructions?
>
> I do not know how to apply the patch on xserver. I have fetched the xserver
> source with "apt-get source xserver-xorg", but the source does not contain the
> file to be patched (xf86Crtc.c). Could you give detailed instructions?
>

(In reply to comment #33)
> Again, switching CONFIG_DRM_I915 yields the error "This This feature depends on
> another which has been configured as a module. As a result, this feature will
> be built as a module." when trying to switch from 'm' to 'y' within 'make
> menuconfig'. Could you give detailed instructions?
>
> I do not know how to "confirm that the test is based on the drm-dave/drm-next
> tree". Could you give detailed instructions?
please use the following command to get the Dave's drm-2.6 tree and then switch to drm-next.
   git clone git://git.kernel.org/pub/scm/linux/kernel/git/airlied/drm-2.6.git
>
> I do not know how to apply the patch on xserver. I have fetched the xserver
> source with "apt-get source xserver-xorg", but the source does not contain the
> file to be patched (xf86Crtc.c). Could you give detailed instructions?
>
You can download the xorg-xserver source code from
http://cgit.freedesktop.org/xorg/xserver/commit/?id=xorg-server-1.6.3
and then apply the patch on it.
And from the xorg log it seems that the patch is already applied. And it confirms that the mode(0x0) is related with the linux kernel.

In fact when patch set in comment #13 is applied, the issue will be fixed.
Thanks.
>

I was cloning git://git.kernel.org/pub/scm/linux/kernel/git/anholt/drm-intel, which is containing a branch called 'drm-intel-next'.

However, after cloning git://git.kernel.org/pub/scm/linux/kernel/git/airlied/drm-2.6.git, how can I 'switch to drm-next'?

$ git branch
* master

$ git checkout drm-next
error: pathspec 'drm-next' did not match any file(s) known to git.

(In reply to comment #38)
> I was cloning git://git.kernel.org/pub/scm/linux/kernel/git/anholt/drm-intel,
> which is containing a branch called 'drm-intel-next'.
>
> However, after cloning
> git://git.kernel.org/pub/scm/linux/kernel/git/airlied/drm-2.6.git, how can I
> 'switch to drm-next'?
>
> $ git branch
> * master
>
> $ git checkout drm-next
> error: pathspec 'drm-next' did not match any file(s) known to git.
please use the following command to switch to drm-next branch.
  git branch -r
  git checkout -b origin/drm-next

thanks.
>

I can confirm that with a kernel obtained with the above instructions, the 0x0 mode is not present any more. Also, several missing modes are restored.

(In reply to comment #40)
> I can confirm that with a kernel obtained with the above instructions, the 0x0
> mode is not present any more. Also, several missing modes are restored.
>
Thanks for the confirmation.
As the patch in comment #13 is already shipped in Dave's drm-next tree, IMO this bug can be marked as resolved.
thanks.

Installing the 'drm-next' kernel (see linked upstream issue) fixes the problem. The kernel contains the three patches mentioned in comment #3. Will these be applied for Karmic?

Hi Andreas,

If these patches get merged into the mainline 2.6.31 kernel, Karmic will automatically have them once we rebase. If however, these do not get upstream in time for 2.6.31, we'll need to consider backporting to Karmic. We'll try to keep an eye on this either way. Thanks.

Changed in xserver-xorg-video-intel:
status: Confirmed → Fix Released

Since -rc8 has been rebased and the bug still occurs, it appears to me now is the time to consider backporting the patches.

Hi Andreas,

I've backported the patches to Karmic and have build and posted a test kernel:

http://people.canonical.com/~ogasawara/lp398188/

ie. http://people.canonical.com/~ogasawara/lp398188/linux-image-2.6.31-9-generic_2.6.31-9.30~lp398188oga1_i386.deb

If you could please test and confirm this kernel fixes this issue that would be great. I'll then submit for inclusion in Karmic. Thanks.

Changed in linux (Ubuntu):
assignee: nobody → Leann Ogasawara (leannogasawara)
status: Triaged → In Progress

I just noticed that the 1024x768 mode is still missing from LVDS1. Should I open a new bugreport for this?

Your kernel removes the 0x0 mode, thanks. However, the 1024x768 mode is still missing on LVDS1:

$ xrandr
Screen 0: minimum 320 x 200, current 1920 x 1968, maximum 4096 x 4096
VGA1 connected 1920x1200+0+0 (normal left inverted right x axis y axis) 519mm x 324mm
   1920x1200 60.0*+
   1600x1200 60.0
   1680x1050 60.0
   1280x1024 75.0 60.0
   1152x864 75.0
   1024x768 75.1 60.0
   800x600 75.0 60.3
   640x480 75.0 60.0
   720x400 70.1
LVDS1 connected 1280x768+304+1200 (normal left inverted right x axis y axis) 264mm x 159mm
   1280x768 59.9*+
   800x600 60.3
   640x480 59.9
TV1 disconnected (normal left inverted right x axis y axis)

Thanks for testing and the feedback. I've submitted these to the Ubuntu kernel-team mailing list for consideration:

https://lists.ubuntu.com/archives/kernel-team/2009-September/007144.html

(In reply to comment #42)
> I just noticed that the 1024x768 mode is still missing from LVDS1. Should I
> open a new bugreport for this?
>
If the mode of 1024x768 is still missing for LVDS1, please open a new bug and attach the required xorg.0.log.

It will be great if you can try the patch in https://bugs.freedesktop.org/show_bug.cgi?id=22761#C8 on the xserver and attach the output of xorg.0.log.
thanks.

Unfortunately it seems this will have to wait for Karmic+1 where we'll likely get these included automatically. The large nature of these patches is not ideal (ie think regression potential) just to eliminate a bogus resolution from appearing.

Changed in linux (Ubuntu Karmic):
status: In Progress → Won't Fix

(In reply to comment #43)

> If the mode of 1024x768 is still missing for LVDS1, please open a new bug and
> attach the required xorg.0.log.

Done: https://bugs.freedesktop.org/show_bug.cgi?id=23676

This problem seems to have been fixed in Kernel 2.6.32-rc1.

Geir Ove Myhr (gomyhr) on 2010-02-02
Changed in linux (Ubuntu):
status: In Progress → Fix Released
Changed in xserver-xorg-video-intel:
importance: Unknown → Medium
Changed in xserver-xorg-video-intel:
importance: Medium → Unknown
Changed in xserver-xorg-video-intel:
importance: Unknown → Medium
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.